package com.loafle.overflow.crawler.wmi;

import java.util.Map;

/**
 * Created by root on 17. 4. 12.
 */
public abstract class WMICrawlerOS {

    private static WMICrawlerOS wmiCrawlerOS = null;

    public static WMICrawlerOS getInstance() {

        if(WMICrawlerOS.wmiCrawlerOS == null) {

            String os = System.getProperty("os.name").toLowerCase();

            if(os.indexOf("linux") >= 0) {
                WMICrawlerOS.wmiCrawlerOS = new WMICrawlerLinux();
            } else if(os.indexOf("") >= 0) {
                WMICrawlerOS.wmiCrawlerOS = new WMICrawlerWindows();
            }

        }

        return WMICrawlerOS.wmiCrawlerOS;
    }

    public abstract Object processWMI(Map<String, Object> params) throws Exception;
}
