package com.loafle.overflow.crawler.wmi;

import com.jacob.activeX.ActiveXComponent;
import com.jacob.com.Dispatch;
import com.jacob.com.EnumVariant;
import com.jacob.com.Variant;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by snoop on 2017-04-11.
 */
public class WMICrawlerWindows extends WMICrawlerOS {

    public Object processWMI(Map<String, Object> params) {

//        String id = "administrator";
//        String pw = "!@#$qwer1234";
//        String nameSpace = "root/cimv2";
//        String query = "select * from Win32_OperatingSystem";
//        String ip = "192.168.1.1";

        String id = (String)params.get("id");
        String pw = (String)params.get("pw");
        String nameSpace = (String)params.get("nameSpace");
        String query = (String)params.get("query");
        String ip = (String)params.get("ip");

        ActiveXComponent wmi = null;
        wmi = new ActiveXComponent("WbemScripting.SWbemLocator");

        Variant conRet = wmi.invoke("ConnectServer", new Variant(ip), new Variant(nameSpace), new Variant(id), new Variant(pw));

        ActiveXComponent wmiconnect = new ActiveXComponent(conRet.toDispatch());

        Variant vCollection = wmiconnect.invoke("ExecQuery", new Variant(query));

        EnumVariant enumVariant = new EnumVariant(vCollection.toDispatch());


        Dispatch item = null;

        List<String> columns = null;
        Map<String, String> resultMap = null;
        List<Map<String, String>> resultMapList = new ArrayList<Map<String, String>>();
        while (enumVariant.hasMoreElements()) {

            item = enumVariant.nextElement().toDispatch();

            if (columns == null) {
                columns = getColumns(item);
            }

            resultMap = new HashMap<String, String>();
            String name = null;
            String value = null;

            for(int indexI = 0 ; indexI < columns.size(); ++indexI) {
                name = columns.get(indexI);
                value = Dispatch.call(item, name).toString();
                resultMap.put(name, value);
            }

            resultMapList.add(resultMap);
        }
        return resultMapList;
    }

    protected List<String> getColumns(Dispatch item) {

        List<String> columns = new ArrayList<String>();

        Variant propertyesa = Dispatch.call(item, "Properties_");

        Variant newEnum = Dispatch.call(propertyesa.toDispatch(), "_NewEnum");

        EnumVariant enumv = newEnum.toEnumVariant();

        while (enumv.hasMoreElements()) {
            Dispatch vv = enumv.nextElement().toDispatch();

            String vs = Dispatch.call(vv, "Name").toString();

            columns.add(vs);
        }
        return columns;
    }


}
